Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_output_write_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_output_write_mod.F90	(revision 4727)
@@ -2395,50 +2420,50 @@
 !!!!!!!!!!!! Sorties niveaux de pression NMC !!!!!!!!!!!!!!!!!!!!
 #ifdef CPP_IOIPSL
-#ifndef CPP_XIOS
-  IF (.NOT.ok_all_xml) THEN 
-       ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
-       ! Champs interpolles sur des niveaux de pression
-       DO iff=7, nfiles-1 !--OB: here we deal with files 7,8,9
-
-          CALL histwrite_phy(o_tnondef,tnondef(:,:,iff-6),iff)
-          CALL histwrite_phy(o_ta,twriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_zg,phiwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_hus,qwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_hur,rhwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_ua,uwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_va,vwriteSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_wap,wwriteSTD(:,:,iff-6),iff)
-          IF (vars_defined) THEN
-             DO k=1, nlevSTD
-                DO i=1, klon
-                   IF (tnondef(i,k,iff-6).NE.missing_val) THEN
-                      IF (freq_outNMC(iff-6).LT.0) THEN
-                         freq_moyNMC(iff-6)=(mth_len*un_jour)/freq_calNMC(iff-6)
-                      ELSE
-                         freq_moyNMC(iff-6)=freq_outNMC(iff-6)/freq_calNMC(iff-6)
-                      ENDIF
-                      zx_tmp_fi3d_STD(i,k) = (100.*tnondef(i,k,iff-6))/freq_moyNMC(iff-6)
-                   ELSE
-                      zx_tmp_fi3d_STD(i,k) = missing_val
-                   ENDIF
-                ENDDO
-             ENDDO
-          ENDIF
-          CALL histwrite_phy(o_psbg,zx_tmp_fi3d_STD,iff)
-          IF (vars_defined) THEN
-             DO k=1, nlevSTD
-                DO i=1, klon
-                   IF (O3sumSTD(i,k,iff-6).NE.missing_val) THEN
-                      zx_tmp_fi3d_STD(i,k) = O3sumSTD(i,k,iff-6) * 1.e+9
-                   ELSE
-                      zx_tmp_fi3d_STD(i,k) = missing_val
-                   ENDIF
-                ENDDO
-             ENDDO !k=1, nlevSTD
-          ENDIF
-          CALL histwrite_phy(o_tro3,zx_tmp_fi3d_STD,iff)
-          IF (read_climoz == 2) THEN
+       IF (.NOT. using_xios) THEN
+         IF (.NOT.ok_all_xml) THEN 
+           ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
+           ! Champs interpolles sur des niveaux de pression
+           DO iff=7, nfiles-1 !--OB: here we deal with files 7,8,9
+
+             CALL histwrite_phy(o_tnondef,tnondef(:,:,iff-6),iff)
+             CALL histwrite_phy(o_ta,twriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_zg,phiwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_hus,qwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_hur,rhwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_ua,uwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_va,vwriteSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_wap,wwriteSTD(:,:,iff-6),iff)
              IF (vars_defined) THEN
-                DO k=1, nlevSTD
+               DO k=1, nlevSTD
+                  DO i=1, klon
+                     IF (tnondef(i,k,iff-6).NE.missing_val) THEN
+                       IF (freq_outNMC(iff-6).LT.0) THEN
+                          freq_moyNMC(iff-6)=(mth_len*un_jour)/freq_calNMC(iff-6)
+                       ELSE
+                          freq_moyNMC(iff-6)=freq_outNMC(iff-6)/freq_calNMC(iff-6)
+                       ENDIF
+                       zx_tmp_fi3d_STD(i,k) = (100.*tnondef(i,k,iff-6))/freq_moyNMC(iff-6)
+                     ELSE
+                       zx_tmp_fi3d_STD(i,k) = missing_val
+                     ENDIF
+                  ENDDO
+               ENDDO
+             ENDIF
+             CALL histwrite_phy(o_psbg,zx_tmp_fi3d_STD,iff)
+             IF (vars_defined) THEN
+               DO k=1, nlevSTD
+                  DO i=1, klon
+                    IF (O3sumSTD(i,k,iff-6).NE.missing_val) THEN
+                       zx_tmp_fi3d_STD(i,k) = O3sumSTD(i,k,iff-6) * 1.e+9
+                    ELSE
+                       zx_tmp_fi3d_STD(i,k) = missing_val
+                    ENDIF
+                  ENDDO
+               ENDDO !k=1, nlevSTD
+             ENDIF
+             CALL histwrite_phy(o_tro3,zx_tmp_fi3d_STD,iff)
+             IF (read_climoz == 2) THEN
+               IF (vars_defined) THEN
+                 DO k=1, nlevSTD
                    DO i=1, klon
                       IF (O3daysumSTD(i,k,iff-6).NE.missing_val) THEN
@@ -2448,24 +2473,25 @@
                       ENDIF
                    ENDDO
-                ENDDO !k=1, nlevSTD
+                 ENDDO !k=1, nlevSTD
+               ENDIF
+               CALL histwrite_phy(o_tro3_daylight,zx_tmp_fi3d_STD,iff)
              ENDIF
-             CALL histwrite_phy(o_tro3_daylight,zx_tmp_fi3d_STD,iff)
-          endif
-          CALL histwrite_phy(o_uxv,uvsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_vxq,vqsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_vxT,vTsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_wxq,wqsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_vxphi,vphisumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_wxT,wTsumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_uxu,u2sumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_vxv,v2sumSTD(:,:,iff-6),iff)
-          CALL histwrite_phy(o_TxT,T2sumSTD(:,:,iff-6),iff)
-       ENDDO !nfiles
-  ENDIF
+             CALL histwrite_phy(o_uxv,uvsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_vxq,vqsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_vxT,vTsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_wxq,wqsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_vxphi,vphisumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_wxT,wTsumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_uxu,u2sumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_vxv,v2sumSTD(:,:,iff-6),iff)
+             CALL histwrite_phy(o_TxT,T2sumSTD(:,:,iff-6),iff)
+           ENDDO !nfiles
+         ENDIF
+       ENDIF !.NOT. using_xios
 #endif
-#endif
-#ifdef CPP_XIOS
-  IF (ok_all_xml) THEN 
-!      DO iff=7, nfiles
+
+       IF (using_xios) THEN
+         IF (ok_all_xml) THEN 
+    !      DO iff=7, nfiles
 
 !         CALL histwrite_phy(o_tnondef,tnondef(:,:,3))
@@ -2530,6 +2556,6 @@
           CALL histwrite_phy(o_TxT,T2STD(:,:))
 !      ENDDO !nfiles
-  ENDIF
-#endif
+    ENDIF
+  ENDIF !using_xios
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        IF (iflag_phytrac == 1 ) then
@@ -2655,4 +2681,9 @@
         CALL histwrite_phy(o_xtoliq(ixt), xtl_seri(ixt,:,:))
 
+        DO nsrf = 1, nbsrf ! ajout Camille 8 mai 2023
+        IF (vars_defined)       zx_tmp_fi2d(1 : klon) = fxtevap(ixt,:, nsrf)
+        CALL histwrite_phy(o_xtevap_srf(ixt,nsrf), zx_tmp_fi2d)
+        ENDDO
+
         IF (vars_defined) zx_tmp_fi3d(:,:)=xtl_seri(ixt,:,:)+xts_seri(ixt,:,:)
         CALL histwrite_phy(o_xtcond(ixt), zx_tmp_fi3d)
@@ -2709,8 +2740,7 @@
           ENDDO !  iff
 #endif
-#ifdef CPP_XIOS
           !On finalise l'initialisation:
-          CALL wxios_closedef()
-#endif
+          IF (using_xios) CALL wxios_closedef()
+
           !$OMP END MASTER
           !$OMP BARRIER
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_state_var_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_state_var_mod.F90	(revision 4727)
@@ -54,6 +54,6 @@
 
 
-      REAL, ALLOCATABLE, SAVE :: rain_fall(:), snow_fall(:)
-!$OMP THREADPRIVATE( rain_fall, snow_fall)
+      REAL, ALLOCATABLE, SAVE :: rain_fall(:), snow_fall(:), bs_fall(:)
+!$OMP THREADPRIVATE( rain_fall, snow_fall, bs_fall)
       REAL, ALLOCATABLE, SAVE :: solsw(:), solswfdiff(:), sollw(:)
 !$OMP THREADPRIVATE(solsw, solswfdiff, sollw)
@@ -82,8 +82,8 @@
       REAL, ALLOCATABLE, SAVE :: t_ancien(:,:), q_ancien(:,:)
 !$OMP THREADPRIVATE(t_ancien, q_ancien)
-      REAL, ALLOCATABLE, SAVE :: ql_ancien(:,:), qs_ancien(:,:)
-!$OMP THREADPRIVATE(ql_ancien, qs_ancien)
-      REAL, ALLOCATABLE, SAVE :: prw_ancien(:), prlw_ancien(:), prsw_ancien(:)
-!$OMP THREADPRIVATE(prw_ancien, prlw_ancien, prsw_ancien)
+      REAL, ALLOCATABLE, SAVE :: ql_ancien(:,:), qs_ancien(:,:), qbs_ancien(:,:)
+!$OMP THREADPRIVATE(ql_ancien, qs_ancien, qbs_ancien)
+      REAL, ALLOCATABLE, SAVE :: prw_ancien(:), prlw_ancien(:), prsw_ancien(:), prbsw_ancien(:)
+!$OMP THREADPRIVATE(prw_ancien, prlw_ancien, prsw_ancien, prbsw_ancien)
 #ifdef ISO
       REAL, ALLOCATABLE, SAVE :: xt_ancien(:,:,:),xtl_ancien(:,:,:),xts_ancien(:,:,:)
@@ -102,6 +102,6 @@
       REAL, ALLOCATABLE, SAVE :: rneb_ancien(:,:)
 !$OMP THREADPRIVATE(rneb_ancien)
-      REAL, ALLOCATABLE, SAVE :: qtc_cv(:,:),sigt_cv(:,:)
-!$OMP THREADPRIVATE(qtc_cv,sigt_cv)
+      REAL, ALLOCATABLE, SAVE :: qtc_cv(:,:),sigt_cv(:,:),detrain_cv(:,:),fm_cv(:,:)
+!$OMP THREADPRIVATE(qtc_cv,sigt_cv,detrain_cv,fm_cv)
       REAL, ALLOCATABLE, SAVE :: ratqs(:,:)
 !$OMP THREADPRIVATE(ratqs)
@@ -229,6 +229,6 @@
 !$OMP THREADPRIVATE(ftd)
 ! fqd : convective moistening due to unsaturated downdraughts
-      REAL,ALLOCATABLE,SAVE :: fqd(:,:)     
-!$OMP THREADPRIVATE(fqd)
+      REAL,ALLOCATABLE,SAVE :: fqd(:,:),fqcomp(:,:)     
+!$OMP THREADPRIVATE(fqd,fqcomp)
 #ifdef ISO
       REAL, ALLOCATABLE, SAVE :: fxtd(:,:,:)
@@ -313,4 +313,6 @@
       REAL,ALLOCATABLE,SAVE :: total_rain(:), nday_rain(:)  
 !$OMP THREADPRIVATE(total_rain,nday_rain)
+      REAL,ALLOCATABLE,SAVE :: ndayrain_mth(:)
+!$OMP THREADPRIVATE(ndayrain_mth)
       REAL,ALLOCATABLE,SAVE :: paire_ter(:)
 !$OMP THREADPRIVATE(paire_ter)
@@ -475,6 +477,6 @@
 !$OMP THREADPRIVATE(ale_bl_trig)
 
-      REAL,SAVE,ALLOCATABLE :: ratqs_inter(:,:)
-!$OMP THREADPRIVATE(ratqs_inter)
+      REAL,SAVE,ALLOCATABLE :: ratqs_inter_(:,:)
+!$OMP THREADPRIVATE(ratqs_inter_)
 
 #ifdef ISO
@@ -570,4 +572,5 @@
       ALLOCATE(rain_fall(klon))
       ALLOCATE(snow_fall(klon))
+      ALLOCATE(bs_fall(klon))
       ALLOCATE(solsw(klon), solswfdiff(klon), sollw(klon))
       sollw=0.0
@@ -579,6 +582,6 @@
       ALLOCATE(rugoro(klon))
       ALLOCATE(t_ancien(klon,klev), q_ancien(klon,klev))
-      ALLOCATE(ql_ancien(klon,klev), qs_ancien(klon,klev))
-      ALLOCATE(prw_ancien(klon), prlw_ancien(klon), prsw_ancien(klon))
+      ALLOCATE(ql_ancien(klon,klev), qs_ancien(klon,klev), qbs_ancien(klon,klev))
+      ALLOCATE(prw_ancien(klon), prlw_ancien(klon), prsw_ancien(klon), prbsw_ancien(klon))
       ALLOCATE(u_ancien(klon,klev), v_ancien(klon,klev))
 !!! Rom P >>>
@@ -587,5 +590,5 @@
       ALLOCATE(clwcon(klon,klev),rnebcon(klon,klev))
       ALLOCATE(rneb_ancien(klon,klev))
-      ALLOCATE(qtc_cv(klon,klev),sigt_cv(klon,klev))
+      ALLOCATE(qtc_cv(klon,klev),sigt_cv(klon,klev),detrain_cv(klon,klev),fm_cv(klon,klev))
       ALLOCATE(ratqs(klon,klev))
       ALLOCATE(pbl_tke(klon,klev+1,nbsrf+1))
@@ -658,5 +661,5 @@
       ALLOCATE(sigd(klon))
       ALLOCATE(cin(klon), ALE(klon), ALP(klon))
-      ALLOCATE(ftd(klon,klev), fqd(klon,klev))
+      ALLOCATE(ftd(klon,klev), fqd(klon,klev),fqcomp(klon,klev))
       ALLOCATE(Ale_bl(klon))
       ALLOCATE(ale_wake(klon))
@@ -678,4 +681,5 @@
       ALLOCATE(pfrac_1nucl(klon,klev))
       ALLOCATE(total_rain(klon), nday_rain(klon))
+      ALLOCATE(ndayrain_mth(klon))
       ALLOCATE(paire_ter(klon))
       ALLOCATE(albsol1(klon), albsol2(klon))
@@ -766,5 +770,5 @@
 
       ALLOCATE(ale_bl_trig(klon))
-      ALLOCATE(ratqs_inter(klon,klev))
+      ALLOCATE(ratqs_inter_(klon,klev))
       IF (ok_gwd_rando) THEN
         ALLOCATE(du_gwd_rando(klon, klev))
@@ -800,11 +804,11 @@
 !FC
       DEALLOCATE(treedrg)
-      DEALLOCATE(rain_fall, snow_fall, solsw, solswfdiff, sollw, radsol, swradcorr)
+      DEALLOCATE(rain_fall, snow_fall, bs_fall,solsw, solswfdiff, sollw, radsol, swradcorr)
       DEALLOCATE(zmea, zstd, zsig, zgam)
       DEALLOCATE(zthe, zpic, zval)
       DEALLOCATE(rugoro, t_ancien, q_ancien, clwcon, rnebcon)
-      DEALLOCATE(qs_ancien, ql_ancien, rneb_ancien)
-      DEALLOCATE(prw_ancien, prlw_ancien, prsw_ancien)
-      DEALLOCATE(qtc_cv,sigt_cv)
+      DEALLOCATE(qs_ancien, ql_ancien, qbs_ancien, rneb_ancien)
+      DEALLOCATE(prw_ancien, prlw_ancien, prsw_ancien, prbsw_ancien)
+      DEALLOCATE(qtc_cv,sigt_cv,detrain_cv,fm_cv)
       DEALLOCATE(u_ancien, v_ancien)
       DEALLOCATE(tr_ancien)                           !RomP
@@ -854,5 +858,5 @@
       DEALLOCATE(wd, sigd)
       DEALLOCATE(cin, ALE, ALP)
-      DEALLOCATE(ftd, fqd)
+      DEALLOCATE(ftd, fqd, fqcomp)
       DEALLOCATE(Ale_bl, Alp_bl)
       DEALLOCATE(ale_wake)
@@ -872,4 +876,5 @@
       DEALLOCATE(pfrac_1nucl)
       DEALLOCATE(total_rain, nday_rain)
+      DEALLOCATE(ndayrain_mth)
       DEALLOCATE(paire_ter)
       DEALLOCATE(albsol1, albsol2)
@@ -902,5 +907,5 @@
       DEALLOCATE(swdnc0_s2, swdn0_s2, swdn_s2)
       DEALLOCATE(swupc0_s2, swup0_s2, swup_s2)
-      
+
 !IM ajout variables CFMIP2/CMIP5
       DEALLOCATE(heatp, coolp)
@@ -933,5 +938,5 @@
       if (.not. ok_hines .and. ok_gwd_rando) DEALLOCATE(du_gwd_front)
       DEALLOCATE(ale_bl_trig)
-      DEALLOCATE(ratqs_inter)
+      DEALLOCATE(ratqs_inter_)
 
       if (activate_ocean_skin >= 1) then
